Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## net.sf.saxon.sort
Interface AtomicComparer

All Superinterfaces:
  Serializable

All Known Implementing Classes:
  AtomicSortComparer, CalendarValueComparer, CodepointCollatingComparer, CollatingAtomicComparer, ComparableAtomicValueComparer, DecimalSortComparer, DescendingComparer, DoubleSortComparer, EmptyGreatestComparer, EqualityComparer, GenericAtomicComparer, NumericComparer, TextComparer

    public interface AtomicComparer

extends Serializable

Interface representing an object that can be used to compare two XPath atomic values for equality or for ordering.

Method Summary
`int` | `compareAtomicValues(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects according to the rules for their data type.
`boolean` | `comparesEqual(AtomicValue a, AtomicValue b)` Compare two AtomicValue objects for equality according to the rules for their data type.
`ComparisonKey` | `getComparisonKey(AtomicValue a)` Get a comparison key for an object.

Method Detail

### compareAtomicValues

    int compareAtomicValues(AtomicValue a,
                            AtomicValue b)

  Compare two AtomicValue objects according to the rules for their data type. UntypedAtomic values are compared as if they were strings; if different semantics are wanted, the conversion must be done by the caller.

  Parameters:
    `a` - the first object to be compared. It is intended that this should be an instance of AtomicValue, though this restriction is not enforced. If it is a StringValue, the collator is used to compare the values, otherwise the value must implement the java.util.Comparable interface.
    `b` - the second object to be compared. This must be comparable with the first object: for example, if one is a string, they must both be strings.
  Returns:
    <0 if a0 if a>b
  Throws:
    `ClassCastException` - if the objects are not comparable

### comparesEqual

    boolean comparesEqual(AtomicValue a,
                          AtomicValue b)

  Compare two AtomicValue objects for equality according to the rules for their data type. UntypedAtomic values are compared by converting to the type of the other operand.

  Parameters:
    `a` - the first object to be compared.
    `b` - the second object to be compared.
  Returns:
    true if the values are equal, false if not
  Throws:
    `ClassCastException` - if the objects are not comparable

### getComparisonKey

    ComparisonKey getComparisonKey(AtomicValue a)

  Get a comparison key for an object. This must satisfy the rule that if two objects are equal according to the XPath eq operator, then their comparison keys are equal according to the Java equals() method, and vice versa. There is no requirement that the comparison keys should reflect the ordering of the underlying objects.

Overview | Package | Class | Deprecated | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright (C) Michael H. Kay. All rights reserved.